unit ATfnclib;
{
  AT function library 1.07
  Copyright (C) 2001 by Arpad Toth
  All rights reserved.

  All contents of this file and all other files included in the ATComponents
  archive  are   Copyright (C) 2001 Arpad Toth.  Use and/or  distribution of
  them requires acceptance of the author.

  Special thanks for:
  ---------------------------------------------------------------
  * Mike Shkolnik -> Based function 'MoneyStr' from SMComponents
  *
}

interface
{  Most aviable 63 functions !}

uses
  Windows, SysUtils, Classes, Registry, Forms, Wininet, ShellApi,
  Graphics, MMSystem;

type
  TOnProcess_File = function (Func: String): Boolean;
  TMoneyExpand = (exFullCurrency, exShortCurrency, exNone);

  {String manipulation}
  function LTrim(S:String): String;
  function RTrim(S: String): String;
  function AllTrim(S:String): String;
  function LeftStr(s: string; n: integer): string;
  function RightStr(s: string; n: integer): string;
  function SubStr(s: string; n0, n: integer): string;
  function Space(Sp_length:integer): String;
  function Replicate(C:Char ;Ch_length:integer): String;
  function ReplaceChar(Src : String; FromC, ToC : Char): String;
  function DeleteChar(Src,Ch: String): String;
  function Pad(S: String; P_Length:integer): String;
  function RPad(S:STring; P_Length:integer): String;
  function LPad(S: String; P_Length:integer): String;
  function ZPad(S: String; P_Length:integer): String;
  function FormatPhone(Phone: String): String;
  function AllDigits(S: String): Boolean;
  function IsDigits(S: String) : Boolean;
  function IsAlpha (S: String) : Boolean;
  function StrPosFrom(From: Integer; const srch, where: String): Integer;
  function CharToBool(Value: Char): Boolean;
  function BoolToChar(Value: Boolean): Char;
  function CharCount(Source, Delim: String): Integer;
  function IsHexaDecimal(S: String): Boolean;
  function HexToDecimal(aValue: String): LongInt;
  function DecimalToHex(aValue : LongInt) : String;
  function DecimalToBin(aValue: LongInt): String;
  function BinaryToDec(aValue : String): LongInt;
  function ATMoneyStr(Value: Double; ExpMoney,ExFilier: TMoneyExpand): String;
  function Ceilling(Value: Double) : Integer;
  function Min(X, Y: Integer): Integer;
  function Max(X, Y: Integer): Integer;
  function ATDecrypt(Src: String; Key: Word): String;
  function ATEncrypt(Src: String; Key: Word): String;
  function trKam2Win(S: string): string;
  function trWin2Kam(S: string): string;
  {Date-time manipulation}
  function CTOD(StringToConvert:String ): TDateTime;
  function DTOC(DateToConvert:TDateTime): String;
  function IsYearLeap(Year: Word): Boolean; Overload;
  function IsYearLeap(const Tm: TDateTime): Boolean; Overload;
  function DaysInMonth(const Tm: TDateTime): Byte; Overload;
  function DaysInMonth(AYear, AMonth: Word): Byte; Overload;
  function WeeksInMonth(AYear, AMount: Word): Byte; Overload;
  function WeeksInMonth(const Tm: TDateTime): Byte; Overload;
  function WorkDaysInMonth(AYear, AMonth: Word): Byte; Overload;
  function WorkDaysInMonth(const Tm: TDateTime): Byte; Overload;
  function YearFromDate(Tm: TDateTime): Word;
  function MonthFromDate(Tm: TDateTime): Byte;
  function MonthNameFromDate(Tm: TDateTime): String;
  function DayFromDate(Tm: TDateTime): Byte;
  function Hours(Tm: TDateTime)  : Integer;
  function Minutes(Tm: TDateTime): Integer;
  function Seconds(Tm: TDateTime): Integer;
  {Function manipulation}
  function iif(Condition: Boolean; Val_1, Val_2: Variant): Variant;
  {Files manipulation}
  function InDirFiles(cDirect, AMask: string; Dofnc: TOnProcess_File): TStrings;
  function InDirFilesCount(cDirect, AMask: String): Integer;
  {Internet manipulation}
  function IsIPaddress(const host: String): Boolean;
  function IsConnectedToNet: Boolean;
  {Register manipulation}
  function IsReadyDrive(cDrive:PChar): Boolean;
  function GetRegString(ARoot: Cardinal; const APath, APar, DefVal: String): String;
  procedure SetRegString(ARoot: Cardinal; const APath, APar, AValue: String);
  function UnRegFileExt(AExtension, AExtDescription: String): Boolean;
  function RegFileExt(AExtension, AExtDescription,
                           AFileDescription, AOpenWith, AParamString: String;
                           AIconIndex: Integer): Boolean;
  function IsCDROMStart: Boolean;
  function IsSoundCard: Boolean;
  procedure SoundPlay(Filename: String);
  function IsFileInUse(fName : string ): boolean;
  function OnlyPath(s: String): String;
  function InvertBmp(SourceBmp: TBitmap): TBitmap; //AColor: TColor = $FFFFFF);
  function ExecuteFile(const FileName, Params, DefaultDir: string;
                                       ShowCmd: Integer): THandle;


implementation

// Slovak translation
const
  ExCurrency:    array[1..3] of string[ 2] = ('','y','ov');
  ShCurrency:    array[1..2] of string[ 4] = ('Sk', 'hal.');
  FlCurrency:    array[1..6] of string[15] = ('koruna','koruny','korn','halier','haliere','halierov');
  Thousands:     array[1..4] of string[15] = ('tisc', 'millin', 'billin','trillin');
  Literal:       array[0..19, 1..4] of string[15] =
       (('',           '',           '',            'nula'),
        ('jedna',      'jeden',      'desat',       'sto'),
        ('dve',        'dva',        'dvadsa',     'dvesto'),
        ('tri',        'tri',        'tridsa',     'tristo'),
        ('tyri',      'tyri',      'tyridsa',   'tyristo'),
        ('p',        'p',        'pdesiat',   'psto'),
        ('es',       'es',       'esdesiat',  'essto'),
        ('sedem',      'sedem',      'sedemdesiat', 'sedemsto'),
        ('osem',       'osem',       'osemdesiat',  'osemsto'),
        ('dev',      'dev',      'devdesiat', 'devsto'),
        ('desa',      'desa',      '',            ''),
        ('jedens',   'jedens',   '',            ''),
        ('dvans',    'dvans',    '',            ''),
        ('trins',    'trins',    '',            ''),
        ('trns',    'trns',    '',            ''),
        ('pns',    'pns',    '',            ''),
        ('esns',   'esns',   '',            ''),
        ('sedemns',  'sedemns',  '',            ''),
        ('osemns',   'osemns',   '',            ''),
        ('devns',  'devns',  '',            ''));

  C1 = 52845;
  C2 = 22719;
  MonthNames: array[1..12] of string[3] = (
                  'Jan', 'Feb', 'Mar', 'Apr',
                  'May', 'Jun', 'Jul', 'Aug',
                  'Sep', 'Oct', 'Nov', 'Dec');

//---------------------------------------------------------------
function trKam2Win(S: string): string;
 var i,f: integer; ch: string;
const
 chDos = 'Ŝ饝ɹ';
 chWin = '蝞ȍ';
begin
 if Length(S)>0 then
 begin
  ch := space(length(S));
  for i:=0 to length(s) do
   begin
    f := Pos(s[i],chDos);
    if f <> 0 then
       ch[i] := chWin[f] else ch[i] := s[i];
   end;
   Result := ch;
 end else
 Result := S;
end;
//---------------------------------------------------------------
function trWin2Kam(S: string): string;
 var i,f: integer; ch: string;
const
 chWin = 'Ŝ饝ɹ';
 chDos = '蝞ȍ';
begin
 if Length(S)>0 then
 begin
  ch := space(length(S));
  for i:=0 to length(s) do
   begin
    f := Pos(s[i],chDos);
    if f <> 0 then
       ch[i] := chWin[f] else ch[i] := s[i];
   end;
   Result := ch;
 end else
 Result := S;
// if MessageDlg(ch+#13#10+s, mtWarning, [mbYes, mbNo], 0) = mrNo then Application.Terminate;
end;
//---------------------------------------------------------------
function LTrim(S: string): String;
begin Result := TrimLeft(S); end;
//---------------------------------------------------------------
function RTrim(S: string): String;
begin Result := TrimRight(S); end;
//---------------------------------------------------------------
function AllTrim(S:String): String;
begin Result := Trim(TrimLeft(S)); end;
//---------------------------------------------------------------
function LeftStr(s: string; n: integer): string;
  var i: integer; r: string;
begin
  if n>Length(S) then n := Length(s);
  r:=''; for i:=1 to n do r:=r+s[i]; result:=string(PChar(r));
end;
//---------------------------------------------------------------
function RightStr(s: string; n: integer): string;
  var i,len: integer; r: string;
begin
  r:=''; len:=Length(s)-n;
  if len<0 then len:=0; for i:=len+1 to Length(s) do r:=r+s[i];
  result:=string(PChar(r));
end;
//---------------------------------------------------------------
function SubStr(s: string; n0, n: integer): string;
  var i: integer; r: string;
begin
  r:='';
  for i:=0 to n-1 do r:=r+s[n0+i]; result:=string(PChar(r));
end;
//---------------------------------------------------------------
function Space(Sp_length:integer): String;
  var i:integer;
begin
  Result := '';
  for i := 1 to Sp_length do begin
    Result := Result + ' ';
  end;
end;
//---------------------------------------------------------------
function Replicate(C:Char ; Ch_length:integer): String;
  var i:integer;
begin
  Result := '';
  for i := 1 to Ch_length do begin
    Result := Result + C;
  end;
end;
//---------------------------------------------------------------
function ReplaceChar(Src: String; FromC, ToC : Char): String;
  var FoundPos : Integer;
begin
  FoundPos := Pos(FromC, Src);
  while FoundPos <> 0 Do
  begin
    Src[FoundPos] := ToC;
    FoundPos := Pos(FromC, Src);
  end;
  Result := Src;
end;
//---------------------------------------------------------------
function DeleteChar(Src,Ch: String) : String;
  var chPos : Integer;
begin
  Ch := pchar(Ch);
  chPos := Pos(Ch, Src);
  while chPos > 0 Do
  begin
    Delete(Src, chPos, 1);
    chPos := Pos(Ch, Src);
  end;
  Result := Src;
end;
//---------------------------------------------------------------
function RPad(S:STring; P_Length:integer): String;
begin Result := S+space(P_Length-length(S)); end;
//---------------------------------------------------------------
function LPad(S:String; P_Length:integer): String;
begin Result := space(P_Length-length(S))+S; end;
//---------------------------------------------------------------
function ZPad(S:String; P_Length:integer): String;
begin Result := Replicate('0',P_Length-length(S))+S; end;
//---------------------------------------------------------------
function Pad(S: String; P_Length:integer): String;
begin
  if Length(S) > P_Length then Result := copy(S,1,P_Length)
  else Result := S + space(P_Length-length(S));
end;
//---------------------------------------------------------------
function FormatPhone(Phone: String): String;
  var i: Integer; Digits: String;
begin
  Result := '(   )    -    ';
  Digits := '';
  for i := 1 to length(Phone) do begin
    if (Phone[i] in ['0'..'9']) then begin
      Digits := Digits + Phone[i];
    end;
  end;
  if length(Digits) <= 7 then begin
    Result := '(   ) '+copy(Digits,1,3)+'-'+copy(Digits,4,4);
  end else begin
    Result := '('+Pad(copy(Digits,1,3),3)+') '+Pad(copy(Digits,4,3),3)+'-'+Pad(copy(Digits,7,4),4);
  end;
end;
//---------------------------------------------------------------
function CharToBool(Value: Char): Boolean;
begin
  Result := false;
  if ( UpCase(Value) in ['T', 'Y', 'A']) then Result := true;
end;
//---------------------------------------------------------------
function BoolToChar(Value: Boolean): Char;
begin if Value then result := 'T' else result := 'F'; end;
//---------------------------------------------------------------
function CharCount(Source, Delim: String): Integer;
  var I, C: integer;
begin
  C:= 0;
  for i:=length(Source) downto 0 do
   if Source[I] = Delim then Inc(C);
   Result := C;
end;
//---------------------------------------------------------------
function GetMoneyStr(strValue: ShortString; FirstMoney: Boolean;
                  Expand: TMoneyExpand): String;
var strRevert, PP: ShortString;
    PK: array[1..3] of ShortString;
    DL, k, PG: Integer;
    N: Double;

function GetMoneyExt(Digit: char): Integer;
begin
  Result := 3;
  if (Digit = '1') then
    Result := 1
  else if (Digit in ['2','3','4']) then
    Result := 2;
end;

begin
  strRevert := '000000000000000';

  DL := Length(strValue);
// calculate amount of triads in number
  if (DL mod 3 = 0) then
    N := DL/3
  else
    N := DL/3 + 1;
  N := Int(N);

// create a reverse string with additional '0' in right (up to 15 characters)
  k := 1;
  while (k <= 255) do
  begin
    if (k <= DL) then
      strRevert[k] := strValue[DL - k + 1]
    else
      strRevert[k] := '0';
    Inc(k)
  end;

  Result := '';
  if Expand <> exNone then
  begin
    { if number is zero }
    if (StrToInt(strValue) = 0) then
      Result := Literal[0, 4] + ' '
    else
    begin
      k := 0;
      while (k < N) do
      begin
        PP := '';
        PK[1] := '';
        PK[2] := '';
        PK[3] := '';

        if (strRevert[3 + 3*k] <> '0') then
           PK[1] := Literal[StrToInt(strRevert[3+3*k]), 4]
        else PK[1] := '';

        if (strRevert[2 + 3*k] <> '0') then
        begin
          if (strRevert[2 + 3*k] = '1') then
          begin
            PK[2] := Literal[StrToInt(strRevert[1+3*k])+10, 2];
            PK[3] := '';
          end
          else
          begin
            PK[2] := Literal[StrToInt(strRevert[2+3*k]), 3];
            PK[3] := Literal[StrToInt(strRevert[1+3*k]), 2];
          end;
        end
        else
        begin
          PK[2] := '';
          if (strRevert[1+3*k] = '0') then
            PK[3] := ''
          else
           if Length(strValue)>1 then
            PK[3] := Literal[StrToInt(strRevert[1+3*k]), 2]
           else
            PK[3] := Literal[StrToInt(strRevert[1+3*k]), 1];
        end;

        if k > 0 then
        begin
          if (strRevert[1 + 3*k] <> '0') or
             (strRevert[2 + 3*k] <> '0') or
             (strRevert[3 + 3*k] <> '0') then
          begin
            { if it isn't a first tens (11..19) }
            if (strRevert[2 + 3*k] <> '1') then
             begin
              PP := Thousands[k];
              if ((3*k)>5) then
                  pp := pp +ExCurrency[GetMoneyExt(strRevert[1 + 3*k])];
             end
            else
             begin
              PP := Thousands[k];
              if (3*k)>5 then pp := pp + ExCurrency[3];

             end;

          end
        end;
        Result := PK[1]+ PK[2]+ PK[3]+ PP + Result;
        Inc(k)
      end;
    end;
  end
  else
  Result := strValue;

{ add a currency }
 if StrToInt(strValue)>4 then PG := 3 else
    PG := GetMoneyExt(strValue[DL]);

    if FirstMoney then
     begin
      if Expand = exFullCurrency then Result := Result + ' ' + FlCurrency[PG]
      else Result := Result + ' ' + ShCurrency[1];
     end
    else
     begin
      if Expand = exFullCurrency then Result := Result + ' ' + FlCurrency[PG+3]
      else Result := Result + ' ' + ShCurrency[2];
     end;
end;
//---------------------------------------------------------------
function ATMoneyStr(Value: Double; ExpMoney,ExFilier: TMoneyExpand): String;
begin
Result := GetMoneyStr(
      IntToStr(Trunc(Value)),True,ExpMoney)+' '+
          GetMoneyStr(
      IntToStr(Round(Frac(Value)*100)),False,ExFilier);
end;
//---------------------------------------------------------------
function Ceilling(Value: Double): Integer;
begin
  if (Frac(Value)<>0) then Result := Trunc(Value)+1 else
  Result := Trunc(value);
end;
//---------------------------------------------------------------
function Max(X, Y: Integer): Integer;
begin if X > Y then Result := X else Result := Y; end;
//---------------------------------------------------------------
function Min(X, Y: Integer): Integer;
begin if X < Y then Result := X else Result := Y; end;
//---------------------------------------------------------------
//---------------------------------------------------------------
function ATEncrypt(Src: String; Key: Word): String;
  var I: byte;
begin
  SetLength(Result,length(Src));
  for I := 1 to Length(Src) do begin
    Result[I] := char(byte(Src[I]) xor (Key shr 8));
    if byte(Result[I])>128 then Result[I] := char(Byte(Result[I])-128);
    Key := (byte(Result[I]) + Key) * C1 + C2;
  end;
end;
//---------------------------------------------------------------
function ATDecrypt(Src: String; Key: Word): String;
  var I: byte;
begin
  SetLength(Result,length(Src));
  for I := 1 to Length(Src) do begin
    Result[I] := char(byte(Src[I]) xor (Key shr 8));
    if byte(Result[I])>128 then Result[I] := char(Byte(Result[I])-128);
    Key := (byte(Src[I]) + Key) * C1 + C2;
  end;
end;
//---------------------------------------------------------------
function AllDigits(S: String): Boolean;
  var i: Integer;
begin
  result := true;
  for i := 1 to length(S) do begin
    if not (S[i] in ['0'..'9']) then begin
      result := false;
      break;
    end;
  end;
end;
//---------------------------------------------------------------
function IsDigits(S: String): Boolean;
  var I: integer;
begin
  Result:=False;
  for I:=1 to length(S) do
   if not (S[I] in ['0'..'9']) then Exit;
  Result := True;
end;
//---------------------------------------------------------------
function IsAlpha(S: String): boolean;
  var I: integer;
begin
  Result:=False;
  for I:=1 to length(S) do
   if not ((S[I] in ['A'..'Z']) or (S[I] in ['a'..'z'])) then Exit;
  Result := True;
end;
//---------------------------------------------------------------
function IsHexaDecimal(S: String): Boolean;
  var i: Word;
begin
 Result := False;
  for i:= length(S) downto 0 do begin
    if not (S[i] in ['0'..'9', 'A'..'F', 'a'..'f'])
    then Exit;
  end;
 Result := True;
end;
//---------------------------------------------------------------
function HexToDecimal(aValue: String): LongInt;
var l: LongInt; b: Byte;
begin
  Result := 0;
  if Length(aValue) <> 0 then
   begin
     l := 1;
     b := Length(aValue) + 1;
     repeat
      dec(b);
      if aValue[b] <= '9' then Result := Result + (Byte(aValue[b]) - 48) * l
      else Result := Result + (Byte(aValue[b]) - 55) * l;
      l := l * 16;
     until b = 1;
   end;
end;
//---------------------------------------------------------------
function DecimalToHex(aValue : LongInt) : String;
  var w: Array[1..2] of Word absolute aValue;
      St: String;

  function HexByte(b: Byte): String;
  const
    Hex: Array[$0..$F] of Char = '0123456789ABCDEF';
  begin
    HexByte := Hex[b shr 4] + Hex[b and $F];
  end;

  function HexWord(w: Word): String;
  begin
    HexWord := HexByte(Hi(w)) + HexByte(Lo(w));
  end;

begin
  St := HexWord(w[2]) + HexWord(w[1]);
  while (St[1] = '0') and (Length(St) > 1) do
   Delete(St, 1, 1);
  Result := St;
end;
//---------------------------------------------------------------
function DecimalToBin(aValue: LongInt): String;
  var w: Array[1..2] of Word absolute aValue;
      St: String;

  function BinByte(b: Byte): String;
  const
    Bin: array[False..True] of Char = '01';
  begin
    Result := Bin[b and 128 = 128] + Bin[b and 64 = 64] + Bin[b and 32 = 32] + Bin[b and 16 = 16] +
              Bin[b and 8 = 8] + Bin[b and 4 = 4] + Bin[b and 2 = 2] + Bin[b and 1 = 1];
  end;

  function BinWord(w: Word) : String;
  begin
    BinWord := BinByte(Hi(w)) + BinByte(Lo(w));
  end;

begin
  St := BinWord(w[2]) + BinWord(w[1]);
  while (St[1] = '0') and (Length(St) > 1) do
   Delete(St, 1, 1);
  Result := St;
end;
//---------------------------------------------------------------
function BinaryToDec(aValue : String) : LongInt;
  var l : LongInt; b : Byte;
begin
  Result := 0;
  if Length(aValue) = 0
   then Exit;

  l := 1;
  b := Length(aValue) + 1;
  repeat
   dec(b);
   if aValue[b] = '1'
    then Result := Result + l;
   l := l shl 1;
  until b = 1;
end;
//---------------------------------------------------------------
function CTOD(StringToConvert:String):TDateTime;
  var Zero : Double; DayInt, MonthInt, YearInt: Word;
begin
  Zero := 0.0;
  YearInt := StrToInt(copy(StringToConvert,1,4));
  MonthInt := StrToInt(copy(StringToConvert,5,2));
  DayInt := StrToInt(copy(StringToConvert,7,2));
  if (YearInt=0) or (MonthInt=0) or (DayInt=0) then begin
    result := TDateTime(Zero);
  end else begin
    try
      Result := EncodeDate(YearInt,MonthInt,DayInt);
    except
      Result := TDateTime(Zero);
    end;
  end;
end;
//---------------------------------------------------------------
function DTOC(DateToConvert: TDateTime): String;
  var Zero: Double;
begin
  Zero := 0.0;
  if DateToConvert = TDateTime(Zero) then begin
    result := '        ';
  end else begin
    result := FormatDateTime('YYYYMMDD',DateToConvert);
  end;
end;
//---------------------------------------------------------------
function IsYearLeap(Year: Word): Boolean;
begin
  Result:=((Year and 3)=0) and ((Year mod 100>0) or (Year mod 400=0));
end;
//---------------------------------------------------------------
function IsYearLeap(const Tm: TDateTime): Boolean;
  var  Year, Month, Day: Word;
begin
  DecodeDate(Tm, Year, Month, Day);
  Result:=((Year and 3)=0) and ((Year mod 100>0) or (Year mod 400=0));
end;
//---------------------------------------------------------------
function YearFromDate(Tm: TDateTime): Word;
  var  Year, Month, Day: Word;
begin
  DecodeDate(Tm, Year, Month, Day);
  YearFromDate:= Year;
end;
//---------------------------------------------------------------
function MonthFromDate(Tm: TDateTime): Byte;
  var Year, Month, Day: Word;
begin
  DecodeDate(Tm, Year, Month, Day);
  MonthFromDate:= Month;
end;
//---------------------------------------------------------------
function MonthNameFromDate(Tm: TDateTime): String;
  var Year, Month, Day: Word;
begin
  DecodeDate(Tm, Year, Month, Day);
  MonthNameFromDate:= MonthNames[Month];
end;
//---------------------------------------------------------------
function DayFromDate(Tm: TDateTime): Byte;
  var Year, Month, Day: Word;
begin
  DecodeDate(Tm, Year, Month, Day);
  DayFromDate:= Day;
end;
//---------------------------------------------------------------
function WeeksInMonth(AYear, AMount: Word): Byte;
var over,i,k: word;
begin
 over := DaysInMonth(AYear, AMount);
 k := 0;
 for i:=1 to over do
  if (DayOfWeek(ctod(IntToStr(AYear)+ZPad(IntToStr(AMount),2)+
                ZPad(IntTostr(i),2))) in [1,7]) then inc(k);
 Result := k;
end;
//---------------------------------------------------------------
function WeeksInMonth(const Tm: TDateTime): Byte;
  var Y,M,D: word;
begin
 DecodeDate(Tm, Y, M, D);
 Result := WeeksInMonth(Y,M);
end;
//---------------------------------------------------------------
function WorkDaysInMonth(AYear, AMonth: Word): Byte;
begin
 Result := (DaysInMonth(AYear, AMonth) - WeeksInMonth(AYear, AMonth));
end;
//---------------------------------------------------------------
function WorkDaysInMonth(const Tm: TDateTime): Byte;
  var Y,M,D: word;
begin
 DecodeDate(Tm, Y, M, D);
 Result := WorkDaysInMonth(Y,M);
end;
//---------------------------------------------------------------
function DaysInMonth(AYear, AMonth: Word): Byte;
const
  DaysInMonth: array[1..12] of Integer =
    (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
begin
  Result := DaysInMonth[AMonth];
  if (AMonth = 2) and IsYearLeap(AYear) then Inc(Result); { leap-year Feb is special }
end;
//---------------------------------------------------------------
function DaysInMonth(const Tm: TDateTime): Byte;
  var y,m,d: Word;
begin
  DecodeDate(Tm,y,m,d);
  Result := DaysInMonth(y,m);
end;
//---------------------------------------------------------------
function Seconds(Tm: TDateTime): integer;
  var H, M, S, MS: word;
begin
  DecodeTime(Tm, H, M, S, MS);
  result := H * 3600 + M * 60 + S;
end;
//---------------------------------------------------------------
function Minutes(Tm: TDateTime): integer;
  var H, M, S, MS: word;
begin
  DecodeTime(Tm, H, M, S, MS);
  result := H * 60 + M;
end;
//---------------------------------------------------------------
function Hours(Tm: TDateTime): integer;
  var H, M, S, MS: word;
begin
  DecodeTime(Tm, H, M, S, MS);
  result := H;
end;
//---------------------------------------------------------------
function iif(Condition: Boolean; Val_1, Val_2: Variant): Variant;
begin if Condition then Result := Val_1  else Result := Val_2; end;
//---------------------------------------------------------------
function InDirFiles(cDirect, AMask: string; DoFnc: TOnProcess_File): TStrings;
  var SearchRec: TSearchRec; R: Word; aFiles: TStrings;
begin
  aFiles := TStringList.Create;
  Result := aFiles;
  if cDirect[Length(cDirect)]<>'\' then cDirect := cDirect + '\';
  try
   R := FindFirst(cDirect+AMask, faAnyFile, SearchRec);
  while R = 0 do
  begin
  if (SearchRec.Attr and faDirectory) = 0 then
    begin
      aFiles.Add(SearchRec.Name);
      if (@DoFnc<>Nil) and (DoFnc(cDirect+SearchRec.Name)= False) then exit;
    end;
    R := FindNext(SearchRec);
  end;
  finally
   FindClose(SearchRec);
  end;
end;
//---------------------------------------------------------------
function InDirFilesCount(cDirect, AMask: String): Integer;
  var SearchRec: TSearchRec;
begin
  if cDirect[Length(cDirect)]<>'\' then cDirect := cDirect + '\';
  if FindFirst(cDirect+AMask, faAnyFile, SearchRec)=0 then begin
    Result:= 1;
    while FindNext(SearchRec) = 0
    do Inc(Result);
  end else Result:= 0;
  Windows.FindClose(SearchRec.FindHandle);
end;
//---------------------------------------------------------------
function StrPosFrom(From: Integer; const srch, where: String): Integer;
var
  p: Integer;
  SS: String;
begin
  if from <= 0
  then from:= 1;
  SS:= System.Copy(where, From, Length(where)-From+1);
  p:= System.Pos(srch, SS);
  if p > 0
  then p:= p + from - 1;
  Result:= p;
end;
//---------------------------------------------------------------
function IsIPaddress(const host: String): Boolean;
var
  curp, L: Integer;
  dotposition: array [0..4] of Byte;
begin
  L:= Length(host);
  IsIPaddress:= False;
  dotposition[0]:= 1;
  curp:= 1;
  repeat
    dotposition[curp]:= StrPosFrom(dotposition[curp - 1], '.', host);
    if dotposition[curp] = 0
    then dotposition[curp]:= L + 1;
    if IsDigits(Copy(host, dotposition[curp-1],
      dotposition[curp] - dotposition[curp-1]))
    then Inc(dotposition[curp])
    else Exit;
    Inc(curp);
  until curp > 4;
  if dotposition[4] <> L + 2
  then Exit;
  IsIPaddress:= True;
end;
//---------------------------------------------------------------
function IsConnectedToNet: boolean;
 var dwConnectionTypes: integer;
begin
  dwConnectionTypes :=   INTERNET_CONNECTION_MODEM
                       + INTERNET_CONNECTION_LAN
                       + INTERNET_CONNECTION_PROXY;
  if InternetGetConnectedState(@dwConnectionTypes, 0) then
     Result := True else Result := False;
end;
//---------------------------------------------------------------
function GetRegString(ARoot: Cardinal; const APath, APar, DefVal: String): String;
  var R: TRegistry;
begin
  Result:= DefVal;
  R:= TRegistry.Create;
  R.RootKey:= ARoot;
  if R.OpenKeyReadOnly(APath) then begin
    try
      Result:= R.ReadString(APar);
    except
    end;
  end;
  R.CloseKey;
  R.Free;
end;
//---------------------------------------------------------------
procedure SetRegString(ARoot: Cardinal; const APath, APar, AValue: String);
  var R: TRegistry;
begin
  R:= TRegistry.Create;
  R.RootKey:= ARoot;
  R.CreateKey(APath);
  if R.OpenKeyReadOnly(APath) then begin
    try
      R.WriteString(APar, AValue);
    except
    end;
  end;
  R.CloseKey;
  R.Free;
end;
//---------------------------------------------------------------
function RegFileExt(AExtension, AExtDescription,
  AFileDescription, AOpenWith, AParamString: String;
  AIconIndex: Integer): Boolean;
  var  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
  with Reg do begin
    RootKey := HKEY_CLASSES_ROOT;
    OpenKey(AExtension, True);
    WriteString('', AExtDescription);
    OpenKey('\' + AExtDescription, True);
    WriteString('', AFileDescription);
    OpenKey('DefaultIcon', True);
    WriteString('', AOpenWith + ','+IntToStr(AIconIndex));
    OpenKey('\' + AExtDescription + '\Shell\Open\Command', True);
    WriteString('', '"' + AOpenWith + '" "' + AParamString + '"');
  end;
  Result := True;
  except
    Result := False;
  end;
  Reg.Free;
end;
//---------------------------------------------------------------
function UnRegFileExt(AExtension, AExtDescription: String): Boolean;
  var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    with Reg do
     begin
      RootKey := HKEY_CLASSES_ROOT;
      DeleteKey(AExtension);
      DeleteKey('\' + AExtDescription);
     end;
   Result := True;
  except
   Result := False;
  end;
  Reg.Free;
end;
//---------------------------------------------------------------
function IsReadyDrive(cDrive: PChar): Boolean;
  var OldErrorMode : Word; OldDirectory : String;
begin
   OldErrorMode:=SetErrorMode(SEM_NOOPENFILEERRORBOX);
   GetDir(0, OldDirectory);
   {$I-}
     ChDir(cDrive+':\');
   {$I+}
   if IoResult<> 0 then Result:=False
   else Result:=True;
   ChDir(OldDirectory);
   SetErrorMode(OldErrorMode);
end;
//---------------------------------------------------------------
procedure SoundPlay(Filename: String);
begin
  if FileExists(Filename) and IsSoundCard then
    SndPlaySound(PChar(Filename), SND_ASYNC or SND_NODEFAULT);
end;
//---------------------------------------------------------------
function IsSoundCard: Boolean;
begin Result := WaveOutGetNumDevs >0; end;
//---------------------------------------------------------------
function IsCDROMStart: Boolean;
begin
  Result :=
  (GetDriveType(PChar(Application.ExeName[1]+':\')) = DRIVE_CDROM)
end;
//---------------------------------------------------------------
function IsFileInUse(fName : string ) : boolean;
  var HFileRes : HFILE;
begin
  Result := false;
  if not FileExists(fName) then exit;
  HFileRes := CreateFile(pchar(fName), GENERIC_READ or GENERIC_WRITE,0, nil, OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, 0);
  Result := (HFileRes = INVALID_HANDLE_VALUE);
  if not Result then CloseHandle(HFileRes);
end;
//---------------------------------------------------------------
function OnlyPath(s: String): String;
begin
 while (s[Length(s)] <> '\') and (Length(s) > 0) do s := Copy(s,1,Length(s)-1);
 Result := s;
end;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

function InvertBmp(SourceBmp:Tbitmap): TBitMap;
var
  i,j :longint; 
  tmp : TBitMap;
  Red, Green, Blue: Byte;
  PixelColor: Longint;
begin
  tmp := TBitmap.Create;
  tmp.Transparent := true;
  tmp.width := SourceBmp.width;
  tmp.height := SourceBmp.height; 
  for i := 0 to SourceBmp.width-1 do
  begin
   for j := 0 to SourceBmp.height-1 do 
   begin
    PixelColor := ColorToRGB(SourceBmp.Canvas.Pixels[i,j]);
    Red := PixelColor;
    Green := PixelColor shr 8;
    Blue := PixelColor shr 16;
    red := 255-red;
    green := 255-green;
    blue := 255-blue;
    tmp.canvas.pixels[i,j] := (red shl 8+green) shl 8+blue;
   end;
 end;
 Result := tmp;
end;



end.
